// FaceProps.cpp : implementation file
//

#include "stdafx.h"
#include "wingdi.h"
#include "Haus2.h"
#include "FaceProps.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFaceProps dialog


CFaceProps::CFaceProps(CWnd* pParent /*=NULL*/)
	: CDialog(CFaceProps::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFaceProps)
	iVertex1 = 0;
	iVertex2 = 0;
	iVertex3 = 0;
	iVertex4 = 0;
	csTexName = _T("");
	csFaceType = _T("");
	//}}AFX_DATA_INIT

}


void CFaceProps::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFaceProps)
	DDX_Control(pDX, IDC_CB_FACETYPE, ccbFaceType);
	DDX_Control(pDX, IDC_TEXNAME, ccbTexName);
	DDX_Control(pDX, IDC_FRAME, m_frame);
	DDX_Text(pDX, IDC_FACEPROP_VER1, iVertex1);
	DDX_Text(pDX, IDC_FACEPROP_VER2, iVertex2);
	DDX_Text(pDX, IDC_FACEPROP_VER3, iVertex3);
	DDX_Text(pDX, IDC_FACEPROP_VER4, iVertex4);
	DDX_CBString(pDX, IDC_TEXNAME, csTexName);
	DDX_CBString(pDX, IDC_CB_FACETYPE, csFaceType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFaceProps, CDialog)
	//{{AFX_MSG_MAP(CFaceProps)
	ON_CBN_SELCHANGE(IDC_TEXNAME, OnSelchangeTexname)
	ON_WM_SHOWWINDOW()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFaceProps message handlers

void CFaceProps::OnSelchangeTexname() 
{
	UpdateData(TRUE);
	if (csTexName.Left(5) == "ANIM:") return;

	CDC *pDC = m_frame.GetDC();
	CRect r;
	m_frame.GetClientRect(r);

	int x,y,w,h;
	w = r.right - r.left;
	h = r.bottom - r.top;

	int iTexSize = bin->GetTextureSize(csTexName);
	TRACE("Texture Size %d\n", iTexSize);

	x = (w>>1) - 128;
	y = (h>>1) - 128;
	w = 256;
	h = 256;
		
	BITMAPINFO mybi;
	
	mybi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);

	mybi.bmiHeader.biWidth = iTexSize;
	mybi.bmiHeader.biHeight = -iTexSize;

	mybi.bmiHeader.biPlanes = 1;
	mybi.bmiHeader.biBitCount = 24;
	mybi.bmiHeader.biCompression = BI_RGB;
	mybi.bmiHeader.biSizeImage = 0;
	mybi.bmiHeader.biXPelsPerMeter = 1;
	mybi.bmiHeader.biYPelsPerMeter = 1;
	mybi.bmiHeader.biClrUsed = 0;
	mybi.bmiHeader.biClrImportant = 0;

	SetStretchBltMode(pDC->m_hDC, COLORONCOLOR); 
 

	StretchDIBits(
		pDC->m_hDC,	// handle of device context 
		x,	// x-coordinate of upper-left corner of dest. rect. 
		y,	// y-coordinate of upper-left corner of dest. rect. 
		w,	// width of destination rectangle 
		h,	// height of destination rectangle 
		0,	// x-coordinate of upper-left corner of source rect. 
		0,	// y-coordinate of upper-left corner of source rect. 
		iTexSize,	// width of source rectangle 
		iTexSize,	// height of source rectangle 
		bin->GetBmpTexturePointer(csTexName),	// address of bitmap bits 
		&mybi,	// address of bitmap data 
		DIB_RGB_COLORS,	// usage 
		SRCCOPY 	// raster operation code 
	);
	bin->DrawTextureCoordSquare(x,y,w, iTexSize, bin->GetCurrentFace(), pDC);	
}

BOOL CFaceProps::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	int i;

	iVertex1 = bin->GetFaceVertex(iFace, 0);
	iVertex2 = bin->GetFaceVertex(iFace, 1);
	iVertex3 = bin->GetFaceVertex(iFace, 2);
	iVertex4 = bin->GetFaceVertex(iFace, 3);
	csTexName = bin->GetCurrentFaceTextureName();
	
	// Fill ComboBox with FaceTypeNames
	CStringArray csaFaceTypeNames;
	bin->GetFaceTypeNameArray(csaFaceTypeNames);
	for (i=0; i<csaFaceTypeNames.GetSize(); i++)
		ccbFaceType.AddString(csaFaceTypeNames[i]);

	ccbFaceType.SetCurSel(ccbFaceType.FindStringExact(-1, bin->GetFaceTypeName(bin->GetFaceTextureType(iFace))));

	// Fill ComboBox with TextureNames
	CStringArray csaTextures;
	bin->GetTextureNameArray(csaTextures);
	for (i=0; i<csaTextures.GetSize(); i++)
		ccbTexName.AddString(csaTextures[i]);

	ccbTexName.SetCurSel(ccbTexName.FindString(-1, csTexName));
	
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFaceProps::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	OnSelchangeTexname();
	
	// Do not call CDialog::OnPaint() for painting messages
}
