#ifndef _HAUS2VIEW_H_
#define _HAUS2VIEW_H_

#include "gl\gl.h"
#include "gl\glu.h"
#include "gl\glaux.h"
#include "BINModel.h"
#include "StatusDlg.h"
#include "BrowseDlg.h"

#define MODE_NORMAL (0)
#define MODE_TEXCOORD (1)

#define VIEW_BORDER (4)

// Haus2View.h : interface of the CHausView class
//
/////////////////////////////////////////////////////////////////////////////

class CHausView : public CView
{
protected: // create from serialization only
	CStatusBar csbStatus;
	CVertexStatusDlg *pVertexStatusDlg;
	CBrowseDlg *pBrowseDlg;
	CPoint mouse_x;
	CPoint mouse_y;
	CPoint mouse_z;
	int mx, my, mz;
	GLfloat wAngleX;
	GLfloat wAngleY;
	BOOL shift_pressed;
	BOOL ctrl_pressed;
	int height;
	int width;
	CBINModel bin;
	CHausView();
	DECLARE_DYNCREATE(CHausView)

// Attributes
public:
	void UpdateVertexStatus(void);
	void DrawCurrentTexture(int x, int y, int w, int h, CDC *pDC);
	BOOL show_texture;
	CUIntArray BINpoints;
	int FaceType;
	COLORREF rgbBack;
	BOOL bFollowFace;
	BOOL b3DOnly;
	BOOL b3DAxes;
	BOOL b3DVerts;
	BOOL b3DQuality;
	BOOL bViewBrowse;
	CRect		m_oldRect;
	CClientDC*  m_pDC;
	CString csBINFolder;
	CString csARTFolder;
	CString csTRKFolder;
	CString csACT;
	CString csCurrentName;

// Operations
public:
	void Init();
    BOOL bSetupPixelFormat(void);
    void DrawScene(void);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHausView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	void Texture2JPEG(unsigned char *bBuf, int iWidth, int iHeight, CString csDest);
	CString csAppDir;
	void ActivateVertexStatusDlg(void);
	void WriteConfiguration(void);
	CMapStringToString cmapCfg;

	virtual ~CHausView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	BOOL	m_play;


// Generated message map functions
protected:
	void WriteBINTexturesAsJPEG(CString csDir);
	//{{AFX_MSG(CHausView)
	afx_msg void OnFilePlay();
	afx_msg void OnUpdateFilePlay(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnFileOpen();
	afx_msg void OnFacesProperties();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnFileSave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTexturesLoad();
	afx_msg void OnFacesAdd();
	afx_msg void OnFacesDeleteCurrent();
	afx_msg void OnVerticesSetcoordinates();
	afx_msg void OnModelRotatex();
	afx_msg void OnModelRotatey();
	afx_msg void OnModelRotatez();
	afx_msg void OnVerticesAdd();
	afx_msg void OnModelResize();
	afx_msg void OnModelTranslate();
	afx_msg void OnGroupsDefinefacegroup();
	afx_msg void OnGroupsRestorefacegroup();
	afx_msg void OnFileInsert();
	afx_msg void OnFileImportWavefront();
	afx_msg void OnGroupsDefineVertexGroup();
	afx_msg void OnGroupsRestoreVertexGroup();
	afx_msg void OnFileSaveasbackdrop();
	afx_msg void OnModelNormalizetexture();
	afx_msg void OnModelWritetexturestotextfile();
	afx_msg void OnFileExportWavefront();
	afx_msg void OnFacesFliptexturex();
	afx_msg void OnFacesFliptexturey();
	afx_msg void OnFacesRotatetexture();
	afx_msg void OnVerticesDeletecurrent();
	afx_msg void OnVerticesDeleteallunused();
	afx_msg void OnTexturesDefineanimation();
	afx_msg void OnFileNew();
	afx_msg void OnViewZoomfit();
	afx_msg void OnFaceProperties();
	afx_msg void OnViewWire();
	afx_msg void OnViewSolid();
	afx_msg void OnViewTextured();
	afx_msg void OnViewToggleVertexStatus();
	afx_msg void OnUpdateViewToggleVertexStatus(CCmdUI* pCmdUI);
	afx_msg void OnFaceSelectAll();
	afx_msg void OnFilePreferences();
	afx_msg void OnFaceMultitex();
	afx_msg void OnSelectTextype();
	afx_msg void OnVertexMerge();
	afx_msg void OnView3donly();
	afx_msg void OnUpdateView3donly(CCmdUI* pCmdUI);
	afx_msg void OnViewShowaxes();
	afx_msg void OnUpdateViewShowaxes(CCmdUI* pCmdUI);
	afx_msg void OnViewShowvertices();
	afx_msg void OnUpdateViewShowvertices(CCmdUI* pCmdUI);
	afx_msg void OnView3dquality();
	afx_msg void OnUpdateView3dquality(CCmdUI* pCmdUI);
	afx_msg void OnFileExportVrml();
	afx_msg void OnFileImportTruck();
	afx_msg void OnModelCenterAll();
	afx_msg void OnModelCenterX();
	afx_msg void OnModelCenterY();
	afx_msg void OnModelCenterZ();
	afx_msg void OnFileBrowse();
	afx_msg void OnUpdateFileBrowse(CCmdUI* pCmdUI);
	afx_msg void OnViewFollowcurrent();
	afx_msg void OnUpdateViewFollowcurrent(CCmdUI* pCmdUI);
	afx_msg void OnFaceDeselectAll();
	afx_msg void OnVertsSelectAll();
	afx_msg void OnVertsDeselectAll();
	afx_msg void OnFaceJump();
	afx_msg void OnVertJump();
	afx_msg void OnFaceFlip();
	afx_msg void OnFacegroupFlip();
	afx_msg void OnFaceSelbydir();
	afx_msg void OnViewBgnd();
	afx_msg void OnFileImasc();
	afx_msg void OnGroupsMagic();
	afx_msg void OnFileHell();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
#endif
