// MultitexDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Haus2.h"
#include "MultitexDlg.h"
#include <afxtempl.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMultitexDlg dialog


CMultitexDlg::CMultitexDlg(CWnd* pParent /*=NULL*/, CStringArray *psaTexNames)
	: CDialog(CMultitexDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMultitexDlg)
	csTexture = _T("");
	//}}AFX_DATA_INIT

	psaTextures = psaTexNames;
}


void CMultitexDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMultitexDlg)
	DDX_Control(pDX, IDC_TEXTURES, ccbTextures);
	DDX_Control(pDX, IDC_RECT, statRect);
	DDX_CBString(pDX, IDC_TEXTURES, csTexture);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMultitexDlg, CDialog)
	//{{AFX_MSG_MAP(CMultitexDlg)
	ON_CBN_SELCHANGE(IDC_TEXTURES, OnSelchangeTextures)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_ROTATE, OnRotate)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_BN_CLICKED(IDC_FLIPHORZ, OnFliphorz)
	ON_BN_CLICKED(IDC_FLIPVERT, OnFlipvert)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultitexDlg message handlers

void CMultitexDlg::OnSelchangeTextures() 
{
	UpdateData(TRUE);
	if (csTexture.Left(5) == "ANIM:") return;

	CDC *pDC = statRect.GetDC();
	CRect r;
	statRect.GetClientRect(r);

	int x,y,w,h;
	w = r.right - r.left;
	h = r.bottom - r.top;

	int iTexSize = bin->GetTextureSize(csTexture);
	TRACE("Texture Size %d\n", iTexSize);

	x = (w>>1) - 128;
	y = (h>>1) - 128;
	w = 256;
	h = 256;
		
	BITMAPINFO mybi;
	
	mybi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);

	mybi.bmiHeader.biWidth = iTexSize;
	mybi.bmiHeader.biHeight = -iTexSize;

	mybi.bmiHeader.biPlanes = 1;
	mybi.bmiHeader.biBitCount = 24;
	mybi.bmiHeader.biCompression = BI_RGB;
	mybi.bmiHeader.biSizeImage = 0;
	mybi.bmiHeader.biXPelsPerMeter = 1;
	mybi.bmiHeader.biYPelsPerMeter = 1;
	mybi.bmiHeader.biClrUsed = 0;
	mybi.bmiHeader.biClrImportant = 0;

	SetStretchBltMode(pDC->m_hDC, COLORONCOLOR); 
 

	StretchDIBits(
		pDC->m_hDC,	// handle of device context 
		x,	// x-coordinate of upper-left corner of dest. rect. 
		y,	// y-coordinate of upper-left corner of dest. rect. 
		w,	// width of destination rectangle 
		h,	// height of destination rectangle 
		0,	// x-coordinate of upper-left corner of source rect. 
		0,	// y-coordinate of upper-left corner of source rect. 
		iTexSize,	// width of source rectangle 
		iTexSize,	// height of source rectangle 
		bin->GetBmpTexturePointer(csTexture),	// address of bitmap bits 
		&mybi,	// address of bitmap data 
		DIB_RGB_COLORS,	// usage 
		SRCCOPY 	// raster operation code 
	);

	PaintLines();
	PaintVertices();
}

BOOL CMultitexDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	int i;
	for (i=0; i<psaTextures->GetSize(); i++)
		ccbTextures.AddString(psaTextures->GetAt(i));

	ccbTextures.SetCurSel(0);
		
	int auxx, auxy, auxz;

	bin->GetFaceGroupFaces(cwaFaces);
	bin->GetFaceGroupVertices(cwaVerts);

	if (cwaVerts.GetSize()) {
		bin->GetVertexCoords(cwaVerts[0], maxx, maxy, maxz);
		bin->GetVertexCoords(cwaVerts[0], minx, miny, minz);
	}

	for (i=0; i<cwaVerts.GetSize(); i++) {
		TRACE("Vertex %d is in the Selection\n", cwaVerts[i]);
		bin->GetVertexCoords(cwaVerts[i], auxx, auxy, auxz);

		maxx = max(maxx, auxx);
		maxy = max(maxy, auxy);
		maxz = max(maxz, auxz);

		minx = min(minx, auxx);
		miny = min(miny, auxy);
		minz = min(minz, auxz);
	}
	
	long int dx = maxx - minx;
	long int dy = maxy - miny;
	long int dz = maxz - minz;

	TRACE("dx = %d, dy = %d, dz = %d\n", dx, dy, dz);

	BOOL usex, usey, usez;
	usex = usey = usez = FALSE;

	if (dx >= min(dy, dz)) usex = TRUE;
	if (dy >= min(dx, dz)) usey = TRUE;
	if (dz >= min(dx, dy)) usez = TRUE;
	if (usex && usey && usez) usez = FALSE;

	TRACE("Use: %d%d%d\n", usex, usey, usez);

	ua.SetSize(cwaVerts.GetSize());
	va.SetSize(cwaVerts.GetSize());

	if (usex) {
		for (i=0; i<cwaVerts.GetSize(); i++) {
			bin->GetVertexCoords(cwaVerts[i], auxx, auxy, auxz);
			ua[i] = MakeRelative(auxx, minx, maxx);
		}
	}
	if (usex && usey) {
		for (i=0; i<cwaVerts.GetSize(); i++) {
			bin->GetVertexCoords(cwaVerts[i], auxx, auxy, auxz);
			va[i] = MakeRelative(auxy, miny, maxy);
		}
	} 
	if (!usex && usey) {
		for (i=0; i<cwaVerts.GetSize(); i++) {
			bin->GetVertexCoords(cwaVerts[i], auxx, auxy, auxz);
			ua[i] = MakeRelative(auxy, miny, maxy);
		}
	}
	if (usez) {
		for (i=0; i<cwaVerts.GetSize(); i++) {
			bin->GetVertexCoords(cwaVerts[i], auxx, auxy, auxz);
			va[i] = MakeRelative(auxz, minz, maxz);
		}
	}

	BuildLinePaintArrays();

	statRect.GetClientRect(&rectTexture);
	int w,h;
	w = rectTexture.right - rectTexture.left;
	h = rectTexture.bottom - rectTexture.top;

	rectTexture.left   = (w>>1) - 128;
	rectTexture.top    = (h>>1) - 128;
	rectTexture.right  = (w>>1) + 128;
	rectTexture.bottom = (h>>1) + 128;

	// END OF USER CODE
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMultitexDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	OnSelchangeTextures();
	
	// Do not call CDialog::OnPaint() for painting messages
}

double CMultitexDlg::MakeRelative(double dVal, double dMin, double dMax)
{
	if (dMin == dMax) return 0;		// avoid div by zero

	return (dVal-dMin)/(dMax-dMin);
}

void CMultitexDlg::PaintVertices()
{
	CDC *pDC = statRect.GetDC();
	CRect r;
	statRect.GetClientRect(r);

	int i,x,y,w,h;
	w = r.right - r.left;
	h = r.bottom - r.top;

	x = (w>>1) - 128;
	y = (h>>1) - 128;
	w = 256;
	h = 256;

	int ix, iy;
	for (i=0; i<cwaVerts.GetSize(); i++) {
		TRACE("u[%d]=%f, v[%d]=%f\n", i, ua[i], i, va[i]);
		ix = x+255*ua[i];
		iy = y+255*va[i];
		pDC->SetPixelV(ix, iy, RGB(255,0,0));
		pDC->SetPixelV(ix-1, iy, RGB(255,0,0));
		pDC->SetPixelV(ix+1, iy, RGB(255,0,0));
		pDC->SetPixelV(ix, iy-1, RGB(255,0,0));
		pDC->SetPixelV(ix, iy+1, RGB(255,0,0));
	}
}

void CMultitexDlg::PaintLines()
{
	CDC *pDC = statRect.GetDC();
	CRect r;
	statRect.GetClientRect(r);

	int i, j;
	int x,y,w,h;
	w = r.right - r.left;
	h = r.bottom - r.top;

	x = (w>>1) - 128;
	y = (h>>1) - 128;
	w = 256;
	h = 256;

	CPen *oldpen;
	CPen white(PS_SOLID, 1, RGB(255,255,255));
	oldpen = pDC->SelectObject(&white);
	int iOldROP2 = pDC->SetROP2(R2_XORPEN);

	int u1, v1, u2, v2;
	for (i=0; i<cwaLineStart.GetSize(); i++) {

		u1 = x+255*ua[cwaLineStart[i]];
		v1 = y+255*va[cwaLineStart[i]];
		u2 = x+255*ua[cwaLineEnd[i]];
		v2 = y+255*va[cwaLineEnd[i]];
		pDC->MoveTo(u1, v1);
		pDC->LineTo(u2, v2);
	}
	pDC->SetROP2(iOldROP2);
	pDC->SelectObject(oldpen);
}

int CMultitexDlg::GetVertexIndex(int iVertex)
{
	for (int i=0; i<cwaVerts.GetSize(); i++)
		if (cwaVerts[i] == iVertex) return i;

	return -1;	// provoke error...
}

CMultitexDlg::~CMultitexDlg()
{
	ua.RemoveAll();
	va.RemoveAll();
	cwaVerts.RemoveAll();
	cwaFaces.RemoveAll();
}

void CMultitexDlg::OnRotate() 
{
	double uold, vold;
	for (int i=0; i<ua.GetSize(); i++) {
		uold = ua[i];
		vold = va[i];
		ua[i] = vold;
		va[i] = 1.0-uold;
	}
	OnSelchangeTextures();
}

void CMultitexDlg::BuildLinePaintArrays()
{
	int i,j;
	int iVerts = cwaVerts.GetSize();

	CWordArray cwaDrawn;
	cwaDrawn.SetSize(iVerts * iVerts);
	for (i=0; i<cwaDrawn.GetSize(); i++)
		cwaDrawn[i]=0;

	int ix, iy;
	int iVtxIdx, iOldVtxIdx;
	int old_u, old_v, u, v;
	CWordArray cwaFaceVerts;
	for (i=0; i<cwaFaces.GetSize(); i++) {
		bin->GetFaceVertexList(cwaFaces[i], cwaFaceVerts);

		iOldVtxIdx = GetVertexIndex(cwaFaceVerts[cwaFaceVerts.GetUpperBound()]);
		for (j = 0; j<cwaFaceVerts.GetSize(); j++) {
			iVtxIdx = GetVertexIndex(cwaFaceVerts[j]);
			if (!cwaDrawn[iOldVtxIdx*iVerts + iVtxIdx]) {
				cwaLineStart.Add(iOldVtxIdx);
				cwaLineEnd.Add(iVtxIdx);
				cwaDrawn[iOldVtxIdx*iVerts + iVtxIdx] = 1;
				cwaDrawn[iVtxIdx*iVerts + iOldVtxIdx] = 1;
			}
			iOldVtxIdx = iVtxIdx;
		}
	}
}

void CMultitexDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	if (bBDdown && (nFlags & MK_LBUTTON) == MK_LBUTTON) {
		CDC *pDC;
		pDC = statRect.GetDC();
		MapWindowPoints(&statRect, &point, 1);

		if (iBDv != -1) {	// move selected vertex
			double newu, newv;
			CoordsToRel(point.x, point.y, newu, newv);
			ua[iBDv] = newu;
			va[iBDv] = newv;
			OnSelchangeTextures();
		} else { // move all vertices
			double transx = double(point.x-iBDx)/256.0;
			double transy = double(point.y-iBDy)/256.0;

			for (int i=0; i<ua.GetSize(); i++) {
				ua[i] = max(0.0, min(uoa[i]+transx, 1.0));
				va[i] = max(0.0, min(voa[i]+transy, 1.0));
			}
			OnSelchangeTextures();
		}
	}
	else if (bBDdown && (nFlags & MK_RBUTTON) == MK_RBUTTON) {
		CDC *pDC;
		pDC = statRect.GetDC();
		MapWindowPoints(&statRect, &point, 1);

		double scalex = double(point.x)/double(iBDx);
		double scaley = double(point.y)/double(iBDy);

		for (int i=0; i<ua.GetSize(); i++) {
			ua[i] = max(0.0, min(uoa[i]*scalex, 1.0));
			va[i] = max(0.0, min(voa[i]*scaley, 1.0));
		}
		OnSelchangeTextures();
	}
	
	CDialog::OnMouseMove(nFlags, point);
}

void CMultitexDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDC *pDC;
	pDC = statRect.GetDC();
	MapWindowPoints(&statRect, &point, 1);

	if(!((point.x >= rectTexture.left) && (point.x <= rectTexture.right) &&
		(point.y >= rectTexture.top) && (point.y <= rectTexture.bottom))) {
		CDialog::OnLButtonDown(nFlags, point);
		return;
	}

	bBDdown = TRUE;

	TRACE("CMultitexDlg::OnLButtonDown(): (%d, %d)\n",point.x, point.y);
	
	iBDx = point.x;	// remember ButtonDown coordinates
	iBDy = point.y;
	iBDv = GetVertex(iBDx, iBDy, 5);

	uoa.SetSize(ua.GetSize());
	voa.SetSize(va.GetSize());
	for (int i=0; i<ua.GetSize(); i++) {
		uoa[i] = ua[i];
		voa[i] = va[i];
	}
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CMultitexDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	iBDx = iBDy = -1;
	bBDdown = FALSE;

	CDialog::OnLButtonUp(nFlags, point);
}

void CMultitexDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CDC *pDC;
	pDC = statRect.GetDC();
	MapWindowPoints(&statRect, &point, 1);

	if(!((point.x >= rectTexture.left) && (point.x <= rectTexture.right) &&
		(point.y >= rectTexture.top) && (point.y <= rectTexture.bottom))) {
		CDialog::OnRButtonDown(nFlags, point);
		return;
	}

	bBDdown = TRUE;

	TRACE("CMultitexDlg::OnLButtonDown(): (%d, %d)\n",point.x, point.y);
	
	iBDx = point.x;	// remember ButtonDown coordinates
	iBDy = point.y;
	iBDv = GetVertex(iBDx, iBDy, 5);

	uoa.SetSize(ua.GetSize());
	voa.SetSize(va.GetSize());
	for (int i=0; i<ua.GetSize(); i++) {
		uoa[i] = ua[i];
		voa[i] = va[i];
	}

	CDialog::OnRButtonDown(nFlags, point);
}

void CMultitexDlg::OnRButtonUp(UINT nFlags, CPoint point) 
{
	iBDx = iBDy = -1;
	bBDdown = FALSE;
	
	CDialog::OnRButtonUp(nFlags, point);
}

int CMultitexDlg::GetVertex(int iX, int iY, int iRad)
{
	CDC *pDC = statRect.GetDC();
	CRect r;
	statRect.GetClientRect(r);

	int i, j;
	int x,y,w,h;
	w = r.right - r.left;
	h = r.bottom - r.top;

	x = (w>>1) - 128;
	y = (h>>1) - 128;
	w = 256;
	h = 256;

	int u, v;
	for (i=0; i<cwaVerts.GetSize(); i++) {
		u = x+255*ua[i];
		v = y+255*va[i];
		if (abs(iX-u) + abs(iY-v) <= iRad) {
			TRACE("CMultitexDlg::GetVertex() = %d\n", i);
			return i;
		}
	}

	TRACE("CMultitexDlg::GetVertex() = -1\n");
	return -1;
}

void CMultitexDlg::CoordsToRel(int iX, int iY, double & dU, double & dV)
{
	CRect r;
	statRect.GetClientRect(r);

	int x,y,w,h;
	w = r.right - r.left;
	h = r.bottom - r.top;

	x = (w>>1) - 128;
	y = (h>>1) - 128;
	w = 256;
	h = 256;

	dU = double(iX-x)/255.0;
	dV = double(iY-y)/255.0;
	if (dU < 0.0) dU = 0.0;
	if (dV < 0.0) dV = 0.0;
	if (dU > 1.0) dU = 1.0;
	if (dV > 1.0) dV = 1.0;
}

double CMultitexDlg::GetMaxU()
{
	double dVal = ua[0];
	for (int i=0; i<ua.GetSize(); i++)
		dVal = max(dVal, ua[i]);
	return dVal;
}

double CMultitexDlg::GetMaxV()
{
	double dVal = va[0];
	for (int i=0; i<va.GetSize(); i++)
		dVal = max(dVal, va[i]);
	return dVal;
}

double CMultitexDlg::GetMinU()
{
	double dVal = ua[0];
	for (int i=0; i<ua.GetSize(); i++)
		dVal = min(dVal, ua[i]);
	return dVal;
}

double CMultitexDlg::GetMinV()
{
	double dVal = va[0];
	for (int i=0; i<va.GetSize(); i++)
		dVal = min(dVal, va[i]);
	return dVal;
}

void CMultitexDlg::OnOK() 
{
	int i, j, k;

	for (i=0; i<cwaFaces.GetSize(); i++)
		bin->SetFaceTexture(cwaFaces[i], csTexture);

	for (i=0; i<cwaVerts.GetSize(); i++) {
		for (j=0; j<cwaFaces.GetSize(); j++) {
			for (k=0; k<bin->GetFaceNumberOfVertices(cwaFaces[j]); k++) {
				if (bin->GetFaceVertex(cwaFaces[j], k) == cwaVerts[i]) {
					bin->SetFaceVertexTextureCoords(cwaFaces[j], k, 1.0-ua[i], va[i]);
				}
			}
		}
	}
	
	CDialog::OnOK();
}

void CMultitexDlg::OnFliphorz() 
{
	for (int i=0; i<ua.GetSize(); i++)
		ua[i] = 1.0 - ua[i];
	OnSelchangeTextures();
}

void CMultitexDlg::OnFlipvert() 
{
	for (int i=0; i<va.GetSize(); i++)
		va[i] = 1.0 - va[i];
	OnSelchangeTextures();
}
