#if !defined(AFX_MULTITEXDLG_H__D121E960_B20B_11D1_8CF5_AAD713E87D46__INCLUDED_)
#define AFX_MULTITEXDLG_H__D121E960_B20B_11D1_8CF5_AAD713E87D46__INCLUDED_

#include "BINModel.h"	// Added by ClassView
#include <afxtempl.h>
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// MultitexDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMultitexDlg dialog

class CMultitexDlg : public CDialog
{
// Construction
public:
	double GetMaxU(void);
	double GetMaxV(void);
	double GetMinU(void);
	double GetMinV(void);
	void CoordsToRel(int iX, int iY, double &dU, double &dV);
	int GetVertex(int iX, int iY, int iRad);
	void BuildLinePaintArrays(void);
	CMultitexDlg(CWnd* pParent = NULL, CStringArray *psaTexNames = NULL);   // standard constructor
	 ~CMultitexDlg();
	int GetVertexIndex(int iVertex);
	void PaintLines(void);
	void PaintVertices(void);
	double MakeRelative(double dVal, double dMin, double dMax);
	CBINModel *bin;
	CStringArray *psaTextures;
	int iBDx, iBDy, iBDv;
	BOOL bBDdown;
	RECT rectTexture;

// Dialog Data
	//{{AFX_DATA(CMultitexDlg)
	enum { IDD = IDD_MULTITEX };
	CComboBox	ccbTextures;
	CStatic	statRect;
	CString	csTexture;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMultitexDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CArray<double, double> ua, va;
	CArray<double, double> uoa, voa;
	CWordArray cwaVerts;
	CWordArray cwaFaces;
	CWordArray cwaLineStart, cwaLineEnd;

	int maxx, maxy, maxz;
	int minx, miny, minz;
	int dx;
	int dy;
	int dz;
	BOOL usex, usey, usez;


	// Generated message map functions
	//{{AFX_MSG(CMultitexDlg)
	afx_msg void OnSelchangeTextures();
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnRotate();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	virtual void OnOK();
	afx_msg void OnFliphorz();
	afx_msg void OnFlipvert();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTITEXDLG_H__D121E960_B20B_11D1_8CF5_AAD713E87D46__INCLUDED_)
