// PreferencesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Haus2.h"
#include "PreferencesDlg.h"
#include "shlobj.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPreferencesDlg dialog


CPreferencesDlg::CPreferencesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPreferencesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPreferencesDlg)
	csARTDir = _T("");
	csBINDir = _T("");
	csDefPal = _T("");
	csTRKDir = _T("");
	//}}AFX_DATA_INIT
}


void CPreferencesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPreferencesDlg)
	DDX_Text(pDX, IDC_ARTDIR, csARTDir);
	DDX_Text(pDX, IDC_BINDIR, csBINDir);
	DDX_Text(pDX, IDC_DEFPAL, csDefPal);
	DDX_Text(pDX, IDC_TRKDIR, csTRKDir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPreferencesDlg, CDialog)
	//{{AFX_MSG_MAP(CPreferencesDlg)
	ON_BN_CLICKED(IDC_BTN_ARTDIR, OnBtnArtdir)
	ON_BN_CLICKED(IDC_BTN_BINDIR, OnBtnBindir)
	ON_BN_CLICKED(IDC_BTN_DEFPAL, OnBtnDefpal)
	ON_BN_CLICKED(IDC_BTN_TRKDIR, OnBtnTrkdir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPreferencesDlg message handlers

void CPreferencesDlg::OnBtnArtdir() 
{
	LPMALLOC pMalloc;
	/* Get's the Shell's default allocator */
	if (::SHGetMalloc(&pMalloc) == NOERROR)
	{
			BROWSEINFO bi;
			char pszBuffer[MAX_PATH];
			LPITEMIDLIST pidl;
			bi.hwndOwner = GetSafeHwnd();
			bi.pidlRoot = NULL;
			bi.pszDisplayName = pszBuffer;
			bi.lpszTitle = _T("Select .RAW and .ACT Directory");
			bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
			bi.lpfn = NULL;
			bi.lParam = 0;
			// This next call issues the dialog box 
			if ((pidl = ::SHBrowseForFolder(&bi)) != NULL)
			{
					if (::SHGetPathFromIDList(pidl, pszBuffer))
					{ 
					//At this point pszBuffer contains the selected path */
							csARTDir = CString(pszBuffer);
					}
					// Free the PIDL allocated by SHBrowseForFolder
					pMalloc->Free(pidl);
			}
			// Release the shell's allocator 
			pMalloc->Release();
	}
	UpdateData(FALSE);
}

void CPreferencesDlg::OnBtnBindir() 
{
	LPMALLOC pMalloc;
	/* Get's the Shell's default allocator */
	if (::SHGetMalloc(&pMalloc) == NOERROR)
	{
			BROWSEINFO bi;
			char pszBuffer[MAX_PATH];
			LPITEMIDLIST pidl;
			bi.hwndOwner = GetSafeHwnd();
			bi.pidlRoot = NULL;
			bi.pszDisplayName = pszBuffer;
			bi.lpszTitle = _T("Select .BIN Model Directory");
			bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
			bi.lpfn = NULL;
			bi.lParam = 0;
			// This next call issues the dialog box 
			if ((pidl = ::SHBrowseForFolder(&bi)) != NULL)
			{
					if (::SHGetPathFromIDList(pidl, pszBuffer))
					{ 
					//At this point pszBuffer contains the selected path */
							csBINDir = CString(pszBuffer);
					}
					// Free the PIDL allocated by SHBrowseForFolder
					pMalloc->Free(pidl);
			}
			// Release the shell's allocator 
			pMalloc->Release();
	}
	UpdateData(FALSE);
}

void CPreferencesDlg::OnBtnDefpal() 
{
    OPENFILENAME   ofn;
    TCHAR szFileName[128]; 
    TCHAR szFileTitle[128]; 
    LPDISPATCH pdispBrowseHelper = NULL;  
    LPDISPATCH pdispTypeLibrary = NULL;
    LPDISPATCH pdispTypeInfos = NULL;      
    
    szFileName[0] = '\0';
    memset(&ofn, 0, sizeof(ofn));
    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = GetParent()->m_hWnd;
    ofn.lpstrFile = szFileName;
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nMaxFile  = sizeof(szFileName);
    ofn.hInstance = NULL;
    ofn.lpstrFilter  = TEXT("Adobe Color Table *.act\0*.act\0All Files *.*\0*.*\0\0");
    ofn.nFilterIndex = 1;
	CString path = "";
	ofn.lpstrInitialDir = (LPCTSTR)(path);
    ofn.Flags= OFN_FILEMUSTEXIST;    

	if (GetOpenFileName(&ofn)) {
		csDefPal = ofn.lpstrFile;
	}
	UpdateData(FALSE);
}

void CPreferencesDlg::OnBtnTrkdir() 
{
	LPMALLOC pMalloc;
	/* Get's the Shell's default allocator */
	if (::SHGetMalloc(&pMalloc) == NOERROR)
	{
			BROWSEINFO bi;
			char pszBuffer[MAX_PATH];
			LPITEMIDLIST pidl;
			bi.hwndOwner = GetSafeHwnd();
			bi.pidlRoot = NULL;
			bi.pszDisplayName = pszBuffer;
			bi.lpszTitle = _T("Select .TRK Truck File Directory");
			bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
			bi.lpfn = NULL;
			bi.lParam = 0;
			// This next call issues the dialog box 
			if ((pidl = ::SHBrowseForFolder(&bi)) != NULL)
			{
					if (::SHGetPathFromIDList(pidl, pszBuffer))
					{ 
					//At this point pszBuffer contains the selected path */
							csTRKDir = CString(pszBuffer);
					}
					// Free the PIDL allocated by SHBrowseForFolder
					pMalloc->Free(pidl);
			}
			// Release the shell's allocator 
			pMalloc->Release();
	}
	UpdateData(FALSE);
}
