// TexListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Haus2.h"
#include "TexListDlg.h"

#include "BINmodel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTexListDlg dialog


CTexListDlg::CTexListDlg(CWnd* pParent /*=NULL*/, CStringArray *csaTex, CPtrArray *cpaAnims)
	: CDialog(CTexListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTexListDlg)
	m_selection = _T("");
	//}}AFX_DATA_INIT

	sa = csaTex;
	pa = cpaAnims;
}


void CTexListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTexListDlg)
	DDX_Control(pDX, IDC_TEXSEL_PV, m_pv);
	DDX_Control(pDX, IDC_LIST2, m_listbox);
	DDX_LBString(pDX, IDC_LIST2, m_selection);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTexListDlg, CDialog)
	//{{AFX_MSG_MAP(CTexListDlg)
	ON_LBN_SELCHANGE(IDC_LIST2, OnSelchangeList2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTexListDlg message handlers

BOOL CTexListDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	for (int i=0; i<sa->GetSize(); i++)
		m_listbox.AddString(sa->GetAt(i));
	
	sTexAnim *psAux;
	for (i=0; i<pa->GetSize(); i++) {
		psAux = (sTexAnim *)pa->GetAt(i);
		m_listbox.AddString(CString("ANIM:")+psAux->csName);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTexListDlg::OnSelchangeList2() 
{
	UpdateData(TRUE);
	
	if (m_selection.Left(5)=="ANIM:") return;

	
	CDC *pDC = m_pv.GetDC();
	
	CRect r;
	m_pv.GetClientRect(r);
	int x,y,w,h;
	x = 0;
	y = 0;
	w = r.right - r.left;
	h = r.bottom - r.top;
	
	BITMAPINFO mybi;
	
	mybi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	if (bin->GetTextureSize(m_selection) == 64) {
		mybi.bmiHeader.biWidth = bin->GetTextureSize(m_selection);
		mybi.bmiHeader.biHeight = -bin->GetTextureSize(m_selection);
	}
	else if (bin->GetTextureSize(m_selection) == 256) {
		mybi.bmiHeader.biWidth = bin->GetTextureSize(m_selection);
		mybi.bmiHeader.biHeight = -bin->GetTextureSize(m_selection);
	}
	mybi.bmiHeader.biPlanes = 1;
	mybi.bmiHeader.biBitCount = 24;
	mybi.bmiHeader.biCompression = BI_RGB;
	mybi.bmiHeader.biSizeImage = 0;
	mybi.bmiHeader.biXPelsPerMeter = 1;
	mybi.bmiHeader.biYPelsPerMeter = 1;
	mybi.bmiHeader.biClrUsed = 0;
	mybi.bmiHeader.biClrImportant = 0;

	if (bin->GetTextureSize(m_selection) == 64)
		StretchDIBits(
			m_pv.GetDC()->m_hDC,	// handle of device context 
			x,	// x-coordinate of upper-left corner of dest. rect. 
			y,	// y-coordinate of upper-left corner of dest. rect. 
			w,	// width of destination rectangle 
			h,	// height of destination rectangle 
			0,	// x-coordinate of upper-left corner of source rect. 
			0,	// y-coordinate of upper-left corner of source rect. 
			bin->GetTextureSize(m_selection),	// width of source rectangle 
			bin->GetTextureSize(m_selection),	// height of source rectangle 
			bin->GetBmpTexturePointer(m_selection),	// address of bitmap bits 
			&mybi,	// address of bitmap data 
			DIB_RGB_COLORS,	// usage 
			SRCCOPY 	// raster operation code 
		);
	else if (bin->GetTextureSize(m_selection) == 256)
		StretchDIBits(
			m_pv.GetDC()->m_hDC,	// handle of device context 
			x,	// x-coordinate of upper-left corner of dest. rect. 
			y,	// y-coordinate of upper-left corner of dest. rect. 
			w,	// width of destination rectangle 
			h,	// height of destination rectangle 
			0,	// x-coordinate of upper-left corner of source rect. 
			0,	// y-coordinate of upper-left corner of source rect. 
			bin->GetTextureSize(m_selection),	// width of source rectangle 
			bin->GetTextureSize(m_selection),	// height of source rectangle 
			bin->GetBmpTexturePointer(m_selection),	// address of bitmap bits 
			&mybi,	// address of bitmap data 
			DIB_RGB_COLORS,	// usage 
			SRCCOPY 	// raster operation code 
		);
	bin->DrawTextureCoordSquare(x,y,w, bin->GetTextureSize(m_selection), bin->GetCurrentFace(), pDC);	
}
