// MTMTexPool.cpp: implementation of the CMTMTexPool class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MTMTexPool.h"
#include "c:\dev\code\generic classes\opTools.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMTMTexPool::CMTMTexPool()
{
	mapTex.RemoveAll();
	mapAnim.RemoveAll();
}

CMTMTexPool::~CMTMTexPool()
{

}

int CMTMTexPool::ReadTexACT(CString csTex, int iWidth, int iHeight, CString csACT)
{
	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	// Initialization

	CString csTexName = CopTools::GetFileFromPath(csTex);
	csTexName.MakeUpper();
	TRACE("CMTMTexPool::ReadTexACT(%s,%d,%d,%s) - Texture Name: %s\n", csTex, iWidth, iHeight, csACT, csTexName);

	int iSize = iWidth * iHeight;

	void *pAux;
	// check if already in Memory
	if (mapTex.Lookup(csTexName, pAux)) return 0;

	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	// Error Checking
	CString csMsg;
	if (!CopTools::FileExists(csTex)) {
		csMsg.Format("Texture Pool Error:\nTexture \"%s\"\nnot found.", csTex);
		AfxMessageBox(csMsg);
		return -1;
	}

	if (!CopTools::FileExists(csACT)) {
		csMsg.Format("Texture Pool Error:\nColor Table \"%s\"\nnot found.", csTex);
		AfxMessageBox(csMsg);
		return -1;
	}
	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	
	int i, j;

	CFile cfTexture;

	if (!cfTexture.Open(csTex, CFile::modeRead, NULL)) {
		csMsg.Format("Texture Pool Error:\nCould not open \"%s\".", csTex);
		AfxMessageBox(csMsg);
		return -1;
	}

	if (cfTexture.GetLength() < iWidth * iHeight) {
		csMsg.Format("Texture Pool Error:\nFile \"%s\"\ntoo small for %d x %d texture.", csTex, iWidth, iHeight);
		AfxMessageBox(csMsg);
		cfTexture.Close();
		return -1;
	}

	BYTE *pBGR, *buf, *pACT;

	pBGR  = (BYTE *)malloc(3 * iSize);
	pACT  = (BYTE *)malloc(3 * 256);
	buf   = (BYTE *)malloc(iSize);

	cfTexture.Read(buf, iSize);
	cfTexture.Close();

	CFile cfACT;
	cfACT.Open(csACT, CFile::modeRead, NULL); 
	cfACT.Read(pACT, 3*256);
	cfACT.Close();

	for (i=0; i<iSize; i++) {
		pBGR[3*i]   = pACT[3*buf[i]+2];
		pBGR[3*i+1] = pACT[3*buf[i]+1];
		pBGR[3*i+2] = pACT[3*buf[i]];
	}

	free(buf);
	free(pACT);

	// assign values to new sTexture structure
	sTexture *pTex = new sTexture;
	pTex->csName  = csTexName;
	pTex->csACT   = csACT;
	pTex->iWidth  = iWidth;
	pTex->iHeight = iHeight;
	pTex->pBGR    = pBGR;

	mapTex.SetAt(csTexName, pTex);

	return iSize;
}

void CMTMTexPool::ClearTexturePool()
{

}
